/*
Jack Midi Logger - See what MIDI message comes in.
    Copyright (C) 2018  Arnaud Estublier

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see https://www.gnu.org/licenses/gpl.txt.
*/

// generated by Fast Light User Interface Designer (fluid) version 1.0304

#ifndef GUI_h
#define GUI_h
#include <FL/Fl.H>
#include <FL/Fl_Double_Window.H>
#include <FL/Fl_Check_Browser.H>
#include <FL/Fl_Text_Display.H>
#include <FL/Fl_Pack.H>
#include <FL/Fl_Light_Button.H>
#include <queue>
#include <vector>
#include <string>

class GUI {
private:
  // Callback function dedicated to the Pretty Button
  // Change the Text Buffer of Messages to Pretty or Hexa
  static void butPushPretty(Fl_Light_Button*, GUI*);
  static void check_sources(Fl_Widget*, GUI*);

  std::queue<std::vector<std::string>>& q_portsStates;
public:
  GUI(std::queue<std::vector<std::string>>&, char*);
  Fl_Double_Window *root;
  // List of possibles MIDI sources
  Fl_Check_Browser *sources;
  Fl_Text_Display *messages;
  // Text Buffer with raw MIDI datas
  Fl_Text_Buffer *buffer_hexa;
  // Text Buffer with prettyfied MIDI datas
  Fl_Text_Buffer *buffer_pretty;
  Fl_Pack *options;
  // Switch display of MIDI Notes Messages On / Off
  Fl_Light_Button *notes;
  // Switch display of MIDI CC Messages On / Off
  Fl_Light_Button *cc;
  // Switch display of MIDI Messages On / Off
  Fl_Light_Button *other;
  // Switch display of MIDI Song
  Fl_Light_Button *song;
  // Switch display of MIDI After
  Fl_Light_Button *aftertouch;
  // Switch display of MIDI SysEx
  Fl_Light_Button *sysex;
  // Pretty or Not ?
  Fl_Light_Button *pretty;
};
#endif
